// "Star Mixer" 
// Written by Eric Ison with Visual C++ Express Edition
// v1.00 2006-Sep-04
// v1.01 2006-Sep-06

// The game "Galactic Civilizations II: Dread Lords" is the property of Stardock

#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <string.h>

void sleep(unsigned int mseconds)
{
    clock_t goal = mseconds + clock();
    while (goal > clock());
}

int main()
{
	using std::cout;
	using std::ifstream;
	using std::ofstream;

	cout << "** Star Mixer v1.01 written by Eric Ison **\n\n";
	cout << "The game \"Galactic Civilizations II: Dread Lords\" is the property of Stardock\n\n";

	ifstream in_stream;
	ofstream out_stream;

	cout << "Opening STARS.txt  -  ";
	in_stream.open("STARS.txt");
	if (in_stream.fail())
	{
		cout << "\n\n";
		cout << "Error opening STARS.txt... Program terminating...\n\n";
		sleep(10000);
		exit(1);
	}

	cout << "Opening STARS_mix.txt  -  ";
	out_stream.open("STARS_mix.txt");
	if (out_stream.fail())
	{
		cout << "\n\n";
		cout << "Error opening STARS_mix.txt... Program terminating...\n\n";
		sleep(10000);
		exit(1);
	}

	char starname[2000][32];
	char temp_str[1][32];
	float random_number;
	int starcount = 0;
	int random_index1, random_index2, last_index;

	cout << "Reading STARS.txt\n";

	// get star names and store in starname array
	for (int i = 0; i < 2000; i++) 
	{
		in_stream.getline(starname[i],32);
		if (! in_stream.eof())
		{
			//cout << "Reading star number "<< (i + 1) << ", \"" << starname[i] << "\"\n";
			starcount++;
		}		
	}

	// seed randomizer
	srand((unsigned)time(0));

	last_index = (starcount - 1);
	cout << "Number of star names in STARS.txt = " << starcount << "\n";
	cout << "Now mixing stars... Please Wait...\n\n";

	for (unsigned long int shuffle_count = 0; shuffle_count < 10000000; shuffle_count++)
	{
		//generate random indexes
		random_number = (float)rand()/(RAND_MAX);
		random_index1 = last_index * random_number; 

		random_number = (float)rand()/(RAND_MAX);
		random_index2 = last_index * random_number;

		//swap strings
		strcpy_s(temp_str[0], starname[random_index1]);
		strcpy_s(starname[random_index1], starname[random_index2]);
		strcpy_s(starname[random_index2], temp_str[0]);
		
		if(shuffle_count == 0)
		{
			cout << "10...";
		}
		if(shuffle_count == 999999)
		{
			cout << "9...";
		}
		if(shuffle_count == 1999999)
		{
			cout << "8...";
		}
		if(shuffle_count == 2999999)
		{
			cout << "7...";
		}
		if(shuffle_count == 3999999)
		{
			cout << "6...";
		}
		if(shuffle_count == 4999999)
		{
			cout << "5...";
		}
		if(shuffle_count == 5999999)
		{
			cout << "4...";
		}
		if(shuffle_count == 6999999)
		{
			cout << "3...";
		}
		if(shuffle_count == 7999999)
		{
			cout << "2...";
		}
		if(shuffle_count == 8999999)
		{
			cout << "1...";
		}
		if(shuffle_count == 9999999)
		{
			cout << "0...\n\n";
		}
	}

	cout << "Writing STARS_mix.txt  -  ";

	for (int j = 0; j < (starcount); j++)
	{
		out_stream << starname[j] << "\n";
		//cout << "Writing star number " << j <<", \"" << starname[j] << "\"\n";
	}

	in_stream.close();
	cout << "Closing STARS.txt  -  ";

	out_stream.close();
	cout << "Closing STARS_mix.txt\n\n";

	cout << "...DONE!\n";
	cout << "Please back-up your original STARS.txt file\n";
	cout << "and rename STARS_mix.txt to STARS.txt\n\n";

	cout << "********************************************\n";
	cout << "**                                        **\n";
	cout << "**   If you found this program useful,    **\n";
	cout << "**   please donate $1.00 via PayPal to:   **\n";
	cout << "**                                        **\n";
	cout << "**       nosicire@yahoo.com               **\n";
	cout << "**                                        **\n";
	cout << "********************************************\n";
	sleep(15000);

	return 0;
}
